vf.resolution_handlers = new Array();

$(window).load(function() {
  vf.handle_resolution();
  widget.addEventListener('resolution', vf.handle_resolution, false);
});

$(function() {
  if (vf.debug == '1') {
    $('#page').append('<div id="debug"></div>');
  }
  if (vf.reload == '1') {
    $('#page').append('<div id="reload"><div id="opacity"></div><img src="css/img/reload.gif" id="spinner" /></div>');
    $('#spinner').css({'margin':'-'+($('#spinner').height()/2)+'px 0 0 -'+($('#spinner').width()/2)+'px'})
  }
  vf.init_widget();
  // init start page
  if (typeof(vf.initial_page) != 'undefined') {
    vf.show_page(vf.initial_page);
  }
});

vf.add_resolution_handler = function(func) {
  vf.resolution_handlers.push(func);
}

vf.handle_resolution = function() {
  var page = $('#page');
  var navs = $('.header, .footer');

  var widget_mode = widget.widgetMode;
  if (widget_mode == 'widget') { // On desktop
    vf.width = window.innerWidth;
    vf.height = window.innerHeight;

    page.width(vf.width + 'px');
    page.height(vf.height + 'px');
    navs.width(vf.width + 'px');

    for (var i in vf.resolution_handlers) {
      vf.resolution_handlers[i](vf.width, vf.height);
    }
  } else if (widget_mode == 'application') { // On mobile
    vf.width = screen.availWidth-7;
    vf.height = screen.availHeight - (android.getScreenDensity() * 50) - 1;

    window.resizeTo(vf.width, vf.height);
    page.width(vf.width + 'px');
    page.height(vf.height + 'px');
    navs.width(vf.width + 'px');

    for (var i in vf.resolution_handlers) {
      vf.resolution_handlers[i](vf.width, vf.height);
    }
  }
}


      vf.set_android_back=function(page_name) {
        var button_search="#"+page_name+"_page .btn[class*='back']";
        var button=$(button_search);                
        if (button.size()>0) {
          android.setBackButtonJSEnabled(true);
          widget.android_back=function() { $(button).trigger('mousedown'); }
        } else {
          android.setBackButtonJSEnabled(false);
        }
      }; 
vf.show_page = function(page_name) {      vf.set_android_back(page_name);

  $('div.page').css({'visibility':'visible'});
  $('div.page').hide();
  if (vf.splash == '1') $('#splash').hide();
  if (vf.reload == '1') $('#reload').hide();
  vf.current_page = page_name;
  vf.init_page(page_name);
  window.scroll(0,0);
}

vf.init_widget = function() {
  if (typeof vf.pages == 'object') {
    for(var page in vf.pages){
      if (typeof vf.pages[page] == 'object') {
        nav_array = [];
        /*
        DOM HEADER ELEMENTS
        */
        if (typeof vf.pages[page].header == 'object') {

          width_def = false;
          $('#'+page+'_page').append('<div class="header"><div class="header_content"></div></div>');
          header_elem = '#'+page+'_page .header .header_content';
          if (vf.pages[page].header.is_active == 1) {
            header_id = nav_array.length - 1;
            header_nav_elements = 0;
            if (typeof vf.pages[page].header.nav_elem == 'object') {
              n = vf.pages[page].header.nav_elem;
              for (var i=0; i < n.length; i++) {
                header_nav_elements++;
                color_class = (n[i].color) ?  ' '+n[i].color : '';
                var txt = vf.get_btn_span_txt(n[i].id, n[i].txt);
                $(header_elem).append('<a href="javascript:;" class="btn'+color_class+' '+n[i].id+'"><span'+vf.get_btn_span_class(n[i].id)+'>'+(txt ? txt : '')+'</span></a>');
                if (typeof n[i].func == 'object') {
                  $(header_elem+' .'+n[i].id).unbind();
                  $(header_elem+' .'+n[i].id).bind(n[i].func.evt, n[i].func.action);
                }
                if (typeof n[i].width_class != 'undefined') {
                  $(header_elem+' a.'+n[i].id).wrap( $("<div class=\"" + n[i].width_class + "\"></div>") );
                  width_def = true;
                }          
              }
            }

            if (header_nav_elements > 0 && width_def == false) {
              if (header_nav_elements==2) { $(header_elem+' a').wrap( $("<div class='c50l'></div>") ); }
              if (header_nav_elements==3) { $(header_elem+' a').wrap( $("<div class='c33l'></div>") ); }
              if (header_nav_elements==4) { $(header_elem+' a').wrap( $("<div class='c25l'></div>") ); }
              if (header_nav_elements > 4) { $(header_elem+' a').wrap( $("<div></div>") ); }
            }
            if (header_nav_elements > 0) {
              $(header_elem).wrapInner( $("<div class='subcolumns'></div>") );
            }
            if (header_nav_elements > 0 && width_def == false) {
              $(header_elem+' .subcolumns').addClass('equalize');
            }
          }
        }

        /*
        DOM CONTENT ELEMENTS IF YOU NEED IT
        */
        // if (typeof vf.pages[page].content.nav == 'object') {
        // };


        /*
        DOM FOOTER ELEMENTS
        */
        if (typeof vf.pages[page].footer == 'object') {
          
          width_def = false;
          $('#'+page+'_page').append('<div class="footer"><div class="footer_content"></div></div>');
          footer_elem = '#'+page+'_page .footer .footer_content';
          if (vf.pages[page].footer.is_active == 1) {
            footer_id = nav_array.length - 1;
            footer_nav_elements = 0;
            if (typeof vf.pages[page].footer.nav_elem == 'object') {
              n = vf.pages[page].footer.nav_elem;
              for (var i=0; i < n.length; i++) {
                footer_nav_elements++;
                color_class = (n[i].color) ?  ' '+n[i].color : '';
                var txt = vf.get_btn_span_txt(n[i].id, n[i].txt);
                $(footer_elem).append('<a href="javascript:;" class="btn'+color_class+' '+n[i].id+'"><span'+vf.get_btn_span_class(n[i].id)+'>'+(txt ? txt : '')+'</span></a>');
                if (typeof n[i].func == 'object') {
                  $(footer_elem+' .'+n[i].id).unbind();
                  $(footer_elem+' .'+n[i].id).bind(n[i].func.evt, n[i].func.action);
                }
                if (typeof n[i].width_class != 'undefined') {
                  $(footer_elem+' a.'+n[i].id).wrap( $("<div class=\"" + n[i].width_class + "\"></div>") );
                  width_def = true;
                }
              }
            }

            if (footer_nav_elements > 0 && width_def == false) {
              if (footer_nav_elements==2) { $(footer_elem+' a').wrap( $("<div class='c50l'></div>") ); }
              if (footer_nav_elements==3) { $(footer_elem+' a').wrap( $("<div class='c33l'></div>") ); }
              if (footer_nav_elements==4) { $(footer_elem+' a').wrap( $("<div class='c25l'></div>") ); }
            }
            if (footer_nav_elements > 0) {
              $(footer_elem).wrapInner( $("<div class='subcolumns'></div>") );
            }
            if (footer_nav_elements > 0 && width_def == false) {
              $(footer_elem+' .subcolumns').addClass('equalize');
            }
          }
        }
      }

      /* PLEASE NOTICE: The following line is processed by the Android wrapper.
         If modifying it, make sure the wrapper still works. */
            var footer_height = $('div#'+page+'_page .footer').height();
      if (footer_height == null) {
        footer_height = 0;
      }
      $('div#'+page+'_page table.page').css({'height': $('#page').height()-footer_height
 });

    }  
  }
};

vf.special_btn = ['back_default',
'next_default',
'close_default',
'info_default',
'preferences_default',
'reload_default'];
              
vf.get_btn_span_class = function(id) {
  var result = '';
  if(vf.in_array(id, vf.special_btn) == false){
    result = ' class="i18n_' + id + '"';
  }  
  return result;
}
vf.get_btn_span_txt = function(id, txt) {
  var result = '';
  if(vf.in_array(id, vf.special_btn) == false){
    result = txt;
  }  
  return result;
}

vf.in_array = function (item,arr) {
  for(p=0; p<arr.length; p++) {
    if (item == arr[p]) {
      return true;
    }
  }
  return false;
}


vf.init_page = function(page) {

  $('#' + page + '_page').show();
  if (typeof vf.pages[page] == 'object') {
    
    if (vf.pages[page].initialized != 1) {
      nav_array = [];

      /*
      NAV HEADER ELEMENTS
      */
      if (typeof vf.pages[page].header == 'object') {
        header_elem = '#'+page+'_page .header';
        if (vf.pages[page].header.is_active == 1) {
          $(header_elem).show();
          $('div#'+page+'_page .content').css({'padding-top': $(header_elem).height() });
        }
      }

      /*
      NAV CONTENT ELEMENTS
      */
      /*
          if (typeof vf.pages[page].content.nav == 'object') {
          };
      */

      /*
      NAV FOOTER ELEMENTS
      */
      if (typeof vf.pages[page].footer == 'object') {
        footer_elem = '#'+page+'_page .footer';
        if (vf.pages[page].footer.is_active == 1) {
          $(footer_elem).show();
          
          /* PLEASE NOTICE: The following line is processed by the Android wrapper.
             If modifying it, make sure the wrapper still works. */
        }
      }
    }
    if (!vf.pages[page].initialized) {
      vf.pages[page].initialized = 1;
    }
  }

};

vf.show_spinner = function() {
  $('#reload').fadeIn(1000);
  // $('#reload').show();
  // document.getElementById('reload').style.display = 'block';
}
vf.hide_spinner = function() {
  $('#reload').fadeOut(1000);
  // $('#reload').hide();
  // document.getElementById('reload').style.display = 'none';
}