// For adding resolution handler uncomment the following:
//
// vf.add_resolution_handler(function(width, height) {
// });

var since_id=0;
var tweet_query;
var tweet_opt=new Object();
var counter=0;
var scroll_timeout_id=0;
var load_timeout_id=0;
var remove_timeout_id=0;
var history_search=[];

$(function() {
	change_language();
	$('#enter_search_exp').bind('keydown',function(evt) {
		if (evt.keyCode==13) {
			start_tweet_scroller();
		}		
	});

	$('#show_flags').css('display', (vf.config.show_flags ? "block" : "none") );
	show_main_page();
});

vf.traffic=function() {

	var tweet_traffic=false;
	var req_obj;
	var stopped;

	var request_tweets=function() {

		if (stopped) {
			return;
		}

		var url="http://search.twitter.com/search.json?q="+tweet_query+(since_id!=0 ? ("&since_id="+since_id) : "")+(tweet_opt.lang!="*" ? "&lang="+tweet_opt.lang : "");
		req_obj=$.ajax({
			type: 'GET',
			url: url,
			cache: false,
			dataType: 'json',
			beforeSend: function(req) {
			},
			complete: function() {
			},
			success: function(msg,textStatus) {
				var tweets_available=process_tweets(msg);
				end_tweet_traffic();
				scroll_tweets(tweets_available ? 0 : 10);

			},
			error: function(req,textStatus) {
				end_tweet_traffic();
				scroll_tweets(10);
			}
		});
	};

	var show_net_traffic=function(traffic) {
		if (traffic) {
			vf.show_spinner();
		} else {
			vf.hide_spinner();
		}
	};

	var end_tweet_traffic=function() { 
		tweet_traffic=false; 
		show_net_traffic(false); 
	}

	return {
		start:function() { 
			tweet_traffic=true; 
			stopped=false;
			show_net_traffic(true); 
			request_tweets();  
		},		
		block:function() { 
			tweet_traffic=true;
		},		
		running:function() { 
			return tweet_traffic;  
		},
		stop: function() {
			stopped=true;
			if (typeof(req_obj)!="undefined") {
				req_obj.abort();
			}
			end_tweet_traffic();
		},
		resume:function() { 
			stopped=false;
		},
	};
}();


var store_preferences=function() {
	widget.setPreferenceForKey($('#show_user:checked').length,'show_user');
	widget.setPreferenceForKey($('#show_avatar:checked').length,'show_avatar');
	widget.setPreferenceForKey($('#show_time:checked').length,'show_time');
	widget.setPreferenceForKey($('#velocity').val(),'velocity');
	widget.setPreferenceForKey($('#twitter_language').val(),'twitter_language');
	show_main_page();
}

var show_preferences_page=function() {
	var opt=get_tweet_options();
	$('#show_user').attr('checked',opt.user);
	$('#show_avatar').attr('checked',opt.avatar);
	$('#show_time').attr('checked',opt.time);

	var $velocity=$('#velocity');
	$velocity.html('');
	var velocity=$velocity[0];
	for (i=1; i<=15; i=i+1) {
		option = document.createElement('option');
		option.value = i;
		if (i==opt.velocity) {
			option.selected = true;
		}
		option.text = i+" "+i18nFor(i==1 ? "i18n_second" : "i18n_seconds");
		velocity.add(option, null);
	}


	var $twitter_language=$('#twitter_language');
	$twitter_language.html('');
	var twitter_language=$twitter_language[0];
	var tlang=vf.config.twitter_languages;
	for (var i18n_key in tlang) {
		if (tlang.hasOwnProperty(i18n_key)) {
			option = document.createElement('option');
			option.value = tlang[i18n_key];
			if (tlang[i18n_key]==opt.lang) {
				option.selected = true;
			}
			option.text = i18nFor(i18n_key,vf.config.language);
			twitter_language.add(option, null);
		}
	}
	vf.show_page('preferences');
}


var get_tweet_options=function() {
	var opt=new Object();
	var show_avatar=widget.preferenceForKey('show_avatar');
	opt.avatar=(null_or_empty(show_avatar) ? 1 : parseInt(show_avatar));
	var show_time=widget.preferenceForKey('show_time');
	opt.time=(null_or_empty(show_time) ? 1 : parseInt(show_time));
	var show_user=widget.preferenceForKey('show_user');
	opt.user=(null_or_empty(show_user) ? 1 : parseInt(show_user));
	var velocity=widget.preferenceForKey('velocity');
	opt.velocity=(null_or_empty(velocity) ? 5 : parseInt(velocity));
	var lang=widget.preferenceForKey('twitter_language');
	opt.lang=(null_or_empty(lang) ? "*" : lang);
	opt.padding_adjust=$('#enter_search_exp').height()*2;
	return opt;
}

var start_tweet_scroller=function() {

	
	tweet_query=$.trim($('#enter_search_exp').val());
	if (tweet_query.length==0) {
		$('#enter_search_feedback').html(i18nFor('i18n_no_search_defined'));
	} else {
		$('#tweets').css('width',getSize()[0]+'px');
		$('#tweets_page .header .info_default').css('display','none');
		tweet_query=escape(tweet_query);
		$('#enter_search_feedback').html('');
		$('#tweets').css("top",getSize()[1]);
		$('#tweets').html("");
		tweet_opt=get_tweet_options();
		vf.show_page("tweets");
		since_id=0;
		set_history(tweet_query);
		vf.traffic.start();
	}
};


var stop_tweet_scroller=function() {
    vf.stop_timer();
	show_main_page();
};



var set_history=function(expr) {
	var found=false;
	var history_string="";
	for (var i=0; i<history_search.length;i++) {
		if (expr==history_search[i]) {
			// exchange current expression to top
			if (i!=0) {
				history_search[i]=history_search[0];
				history_search[0]=expr;
			}
			found=true;
			break;
		}

	}
	if (!found) {
		history_search.unshift(expr);
		history_search=history_search.slice(0,9);
	}
	for (i=0; i<history_search.length;i++) {
		history_string=history_string+(i>0 ? ";" : "")+history_search[i];
	}
	widget.setPreferenceForKey(history_string,'history');
}


var setup_history=function() {
	var history_string=widget.preferenceForKey('history');
	$select_history_wrapper=$('#select_history_wrapper');
	if (null_or_empty(history_string)) {
		$select_history_wrapper.css('display','none');
	} else {
		history_search=history_string.split(";");
		var $select_history=$('#select_history');
		$select_history.unbind();
		$select_history.html('');

		var select_history=$select_history[0];		
		var option = document.createElement('option');
		option.selected = true;
		option.value = option.text = i18nFor("i18n_history");
		select_history.add(option, null);	
		for (var i=0;i<history_search.length;i++) {
			option = document.createElement('option');
			option.value = option.text=history_search[i];
			select_history.add(option, null);				
		}


		$select_history_wrapper.css('display','block');
		$select_history.bind('change',function() {
			$('#enter_search_exp').val($(this).val());
			$(this).children('option')[0].selected=true;
		} );

	}
}



var show_main_page=function() {
	setup_history();
	vf.show_page("main");

}



var remove_invisible_tweets=function() {
	var visible_tweets=0;
	var i;
	var do_exit=false;
	var tweets=$('#tweets .tweet');
	var deleted_tweets=0;
	var scr_height=getSize()[1];
	
	for (i=0; i<tweets.length; i++) {
		do_exit=true;
		var tweet=tweets.eq(i);
		var tweet_offset=tweet.offset();
		if ( tweet_offset.top<0 ) {
			tweet.addClass('remove');
			deleted_tweets++;
		}
	}
	if (deleted_tweets) {
		$('#tweets .remove').remove();
		var ptweet=$('#tweets');
		ptweet.css('top',0);
	}
}

var process_tweets=function(msg) {
	var tweets=msg.results;
	var text;
	var $eof;
	if (tweets.length>0) {
		text=get_tweet_markup(tweets);
		$eof=$('#tweets #eof');
		if ($eof.length>0) {
			$eof.replaceWith(text);
		} else {
			$('#tweets').append(text);
		}
	} 
	return (tweets.length>0);
}




var parse_urls=function(text) {
	var out="";
	var pos=-1;
	var link;
	do {
		pos=text.search(/http:\/\//);
		if (pos>=0) {
			out=out+text.substring(0,pos);
			text=text.substring(pos);
			pos=text.search(/\s/);
			link=text.substring(0,(pos<0 ? text.length : pos));
			out=out+"<a href='"+link+"'>"+link+"</a>";
			text=(pos<0 ? "" : text.substring(pos));				  
		} else {
			out=out+text;
		}
	} while(pos>=0);
	return out;
}

var get_tweet_markup=function(tweets) {
	var text="";
	var new_since_id=0;
	var date;
	var timage;
	var tuser;
	var an_id;
	var msg;
	var tuser;
	for (var i=tweets.length-1; i>=0;i--) {
		msg=tweets[i]; 			
		an_id=parseInt(msg.id,10);
		new_since_id=(new_since_id<an_id ? an_id : new_since_id) ;
			text=text+"<div class='tweet "+(++counter%2 ? "even" : "odd")+"'>";
		if (tweet_opt.avatar) {
			timage="<img class='avatar' src='"+msg.profile_image_url+"' alt='tweet'/>"; 
			text=text+timage; 
		}
		if (tweet_opt.user) { 
			tuser="<span class='tuser'>"+msg.from_user+"</span> ";
			text=text+tuser; 
		}
		text=text+parse_urls(msg.text);
		if (tweet_opt.time) { 
			date=new Date();
			date.setTime(Date.parse(msg.created_at));
			ttime="&nbsp;<span class='ttime'>("+date.toLocaleTimeString()+")</span>";
			text=text+ttime; 
		}
		text=text+"</div>";
	}
	since_id=(since_id<new_since_id ? new_since_id : since_id);
	text=text+"<div id='eof' class='tweet'>"+i18nFor('i18n_end_of_tweets')+"<br/><span id='update_status'></span></div>";
	return text;
}


var adjust_scrolling=function() {
	var tweets_offset=$('#tweets').offset();
	var tweet_offset;
	var tweets=$('#tweets .tweet');
	var i;
	for (var i=0; i<tweets.length; i++) {
		tweet_offset=tweets.eq(i).offset();
		if (tweet_offset.top>=0) {
			if (tweet_offset.top>0) {
				$("#tweets").animate( {"top": tweets_offset.top-tweet_offset.top },800);
			}
			return;
		} 		

	}
}

var scroll_tweets=function(velocity) {

	if (typeof(velocity)=='undefined' || !velocity) {
		velocity=tweet_opt.velocity;
	}

	var tweets_offset=$('#tweets').offset();
	var tweet_offset;
	var tweets=$('#tweets .tweet');
	var screen_height=getSize()[1];
	var delta;
	var i;
	for (var i=0; i<tweets.length; i++) {
		tweet_offset=tweets.eq(i).offset();
		if (tweet_offset.top>screen_height) {
			delta=tweets.eq(i).height()+tweet_opt.padding_adjust;
			widget.getAttention();
			$("#tweets").animate( {"top": tweets_offset.top-delta}, 800,0);
			break;
		}		
	}		
	if (!vf.traffic.running() && i==tweets.length) {
		vf.traffic.block();
		adjust_scrolling();			
		eof_status(velocity);
		remove_timeout_id=setTimeout( function() { remove_invisible_tweets(); },velocity*1000 )
		load_timeout_id=setTimeout( function() { vf.traffic.start(); },(velocity+1)*1000 )
		return;
	} 
	if (!vf.traffic.running()) {
		scroll_timeout_id=setTimeout( function() { scroll_tweets(); },velocity*1000 );
	}
}

var eof_status=function(count_down) {

	$eof=$('#update_status');
	if ($eof.length>0) {
		if (count_down>0) {
			$eof.html(i18nFor('i18n_update_count_down')+count_down);
			count_down--;
			setTimeout( function() { eof_status(count_down) },1000 );
		} else {
			$eof.html(i18nFor('i18n_updating'));
		}	
	}
}


var getSize = function () {
	var myWidth = window.innerWidth;
	var myHeight = window.innerHeight;
	return [ myWidth, myHeight ];
};



/* if no langague is given as a parameter  use the language which is
   stored in the preference store */
var change_language=function (lang) {
	if (!lang) {
		lang=widget.preferenceForKey('user_lang');
		lang=(null_or_empty(lang) ? vf.language : lang);
	} else {
		widget.setPreferenceForKey(lang,'user_lang');
	}
	$('#main_page .flags').removeClass('act');
	$('#main_page #'+lang).addClass('act');
	vf.language=lang;
	setLang(lang);
	setup_history();

};


var null_or_empty=function (value) {
		return (!value || value.length == 0);
};


//following functions are invoked by the android runtime environment
vf.start_timer=function() {
  vf.traffic.resume();
  scroll_tweets();
};

vf.stop_timer=function() {
	// stop animations
	$("#tweets").stop();
	// stop timeout
	clearTimeout(load_timeout_id);
	clearTimeout(scroll_timeout_id);
	clearTimeout(remove_timeout_id);
	// stop traffic
	vf.traffic.stop();
};

