/**
 * @author Vodafone D2 GmbH
 *
 * Default language must be set for start-up and failing language values
 * All i18n keys used in your html document must have at least the values set in default language!!!
 *
 */
 vf.language = "de";
 vf.defaultLanguage = "en";

 /**
 * lang object to customize your language values.
 * the keys will be presented in html as class names with "i18n_" prefix
 * the language values will be set as element values
 *
 * To internationalize the head-title use the key "title" w/o the "i18n_" prefix!
 *
 * Use "\u" + Java-Unicode character codes (common to JavaScript) for special characters!!!
 * Don't forget to escape the "'" signs like "\'"
 * See http://unicode.org/charts/
 */
 var lang = {
	 title: {
		 de: 'Tweet Zeitgeist',
		 en: 'Tweet Zeitgeist'
	 },
	 i18n_app_title: {
		 de: 'Tweet Zeitgeist',
		 en: 'Tweet Zeitgeist'
	 },
	 i18n_info: {
		 de: 'Info',
		 en: 'Info'
	 },
	 i18n_back: {
		 de: 'Zur\u00FCck',
		 en: 'Back'
	 },
	 i18n_preferences_btn: {
		 de: 'Einstellungen',
		 en: 'Preferences'
	 },
	 i18n_search_btn: {
		 de: 'Suchen',
		 en: 'Search'
	 },
	 i18n_search_for: {
		 de: 'Sucheingabe',
		 en: 'Search for'
	 },
	 i18n_select_language: {
		 de: 'Sprache der Tweets:',
		 en: 'Show only tweets in:'
	 },
	 i18n_show_tweet_details: {
		 de: 'Angezeigte Details:',
		 en: 'Show Details:'
	 },
	 i18n_show_user: {
		 de: 'Twitter Nutzer',
		 en: 'Twitter User'
	 },
	 i18n_show_avatar: {
		 de: 'Avatar (Bild des Nutzers)',
		 en: 'User\'s Avatar'
	 },
	 i18n_show_time: {
		 de: 'Zeit der Nachricht',
		 en: 'Tweet\'s Time'
	 },
	 i18n_select_velocity: {
		 de: 'Geschwindigkeit der Nachrichten',
		 en: 'Speed for tweets'
	 },
	 i18n_info_disclaimer: {
		 de: 'Für die folgenden Internet-Inhalte (Applikationen, Widgets und die damit verknüpften Webseiten) übernimmt Vodafone keine Verantwortung oder Haftung. Die Nutzung wird nach Ihrem Datentarif abgerechnet. Wir empfehlen daher dringend die Buchung eines geeigneten Internet-Datentarifs!',
		 en: 'This application is made available on an "as is" and "as available" basis and you download, install and use this application at your own discretion and risk. Vodafone has no control over the third party sites accessible via the application. Vodafone assumes no responsibility for and does not endorse (unless expressly stated), any third party’s website, products or services which may be linked to or which may be made available from the application, the services or the content or any other content or information published on any third party’s website. Please note that Vodafone cannot be held responsible for and do not actively control, monitor or endorse any information or communication from members of the public which is uploaded to or published on or in any public areas made available in the application or via the services. We recommend subscribing to a data tariff plan when using this application.'
	 },
	 i18n_no_search_defined: {
		 de: 'Bitte geben Sie einen Begriff in das Suchfeld ein',
		 en: 'Please enter a text to search for'
	 },
	 i18n_store_preferences_back_btn: {
		 de: 'Speichern',
		 en: 'Save'
	 },
	 i18n_second: {
		 de: 'Sekunde',
		 en: 'second'
	 },
	 i18n_seconds: {
		 de: 'Sekunden',
		 en: 'seconds'
	 },
	 i18n_update_count_down: {
		 de: 'Update in ', //#
		 en: 'Update in ' //#
	 },
	 i18n_end_of_tweets: {
		 de: 'Ende der Tweets',
		 en: 'End of Tweets'
	 },
	 i18n_updating: {
		 de: 'Aktualisiere...',
		 en: 'Updating...'
	 },
	 i18n_all: {
		 de: 'Alle Sprachen',
		 en: 'Any Languages'
	 },
	 i18n_history: {
		 de: 'Historie',
		 en: 'History'
	 },
	 /* Languages follow... */
	 i18n_de: {
		 de: 'Deutsch',
		 en: 'German'
	 },
	 i18n_en: {
		 de: 'Englisch',
		 en: 'English'
	 },
	 i18n_es: {
		 de: 'Spanisch',
		 en: 'Spanish'
	 },
	 i18n_nl: {
		 de: 'Holländisch',
		 en: 'Dutch'
	 },
	 i18n_fr: {
		 de: 'Französisch',
		 en: 'French'
	 },
	 i18n_it: {
		 de: 'Italienisch',
		 en: 'Italian'
	 },
 }

 /**
 *
 * You can set the language anytime
 * by calling the method setLang(your_language).
 *
*/
 $(document).ready(function(){
     setLang(vf.language);
 });
